package com.bukkit.TJ09;

import java.io.*;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.text.SimpleDateFormat;
import java.util.TimerTask;
import org.bukkit.Location;
import org.bukkit.entity.Player;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

/**
 * Periodic timer that outputs stuff to JSON.
 * @author TJ09
 */
public class MapMarkersTimerTask extends TimerTask {
    private final MapMarkers plugin;
	private String outputFile;
	public SimpleDateFormat dateFormat;

    public MapMarkersTimerTask(MapMarkers instance, String file, String format) {
        plugin = instance;
		outputFile = file;
		
		try {
		dateFormat = new SimpleDateFormat(format);
		
		} catch (IllegalArgumentException e) {
			System.out.println("MapMarkers: Invalid date format, defaulting to yyyyMMdd HH:mm:ss");
			dateFormat = new SimpleDateFormat("yyyyMMdd HH:mm:ss");
		} catch (NullPointerException e) {
			System.out.println("MapMarkers: Invalid date format, defaulting to yyyyMMdd HH:mm:ss");
			dateFormat = new SimpleDateFormat("yyyyMMdd HH:mm:ss");
		}
    }
	
	public void run() {
		JSONArray outList = new JSONArray();
		Player[] players = plugin.getServer().getOnlinePlayers();
		for(Player p: players) {
			JSONObject out = new JSONObject();
			out.put("msg",p.getName());
			out.put("x",p.getLocation().getX());
			out.put("y",p.getLocation().getY());
			out.put("z",p.getLocation().getZ());
			out.put("timestamp",dateFormat.format(plugin.lastSeen.get(p)));
			
			outList.add(out);
		}
		try {
			PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(outputFile)));
			out.print(outList);
			out.close();
		} catch (java.io.IOException e) {
			System.out.println("MapMarkers: Unable to write to file.");
			e.printStackTrace();
		}
	}
}

